import onnx
import ktc
import sys
import os
import numpy as np

original_m = onnx.load(sys.argv[1])

basename = os.path.basename(sys.argv[1])
name = os.path.splitext(basename)[0]

print('optimizing onnx ...')
optimized_m = ktc.onnx_optimizer.torch_exported_onnx_flow(original_m)
optimized_m =  ktc.onnx_optimizer.onnx2onnx_flow(optimized_m, eliminate_tail=True, opt_matmul=False)

onnx.save(optimized_m, 'weights/optimized.onnx')

platform = sys.argv[2]

km = ktc.ModelConfig(32800, "0001", platform, onnx_model=optimized_m)

print('evaluating ...')
eval_result = km.evaluate()

input_data = [np.random.randint(0, 256, (1, 3, 640, 640))]

input_mapping = {[i.name for i in original_m.graph.input][0]: input_data}
print('bie convertion ...')
bie_path = km.analysis(input_mapping, threads = 8)
print(f'bie path: {bie_path}')

# fixed_point_inf_results_bietest = ktc.kneron_inference(
#     input_data, 
#     bie_file=bie_path, 
#     input_names=[f"{sys.argv[4]}"], 
#     platform=720
# )

if not os.path.exists(sys.argv[3]):
    os.mkdir(sys.argv[3])

print('nef convertion ...')
nef_path = ktc.compile([km], os.path.join(os.path.abspath(sys.argv[3]), name))

print(nef_path)

# binary_inf_results = ktc.kneron_inference(input_data, nef_file=nef_path, input_names=[f"{sys.argv[4]}"], platform=720)